/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/* abgenderte Version fr AT90S2313  angepasst   10.1.2013                                                                   */
/************************************************************************/
#include "main.h"
#include "lcd-routines.h"
#include <util/delay.h>

//die itoa-Funktion aus der Bibliothek befindet sich normalerweise in stdlib.h, die in main.h eingebunden wird.

/*
Variante fr den SIMULATOR!!!!!!!!!!!!!!!!!!!


zustzlich ins Projekt mit einbinden: (wird allerdings berhaupt nicht gebraucht)

rc5.c
LCD-Routines.c

*/


/*
Verwendung des neuen Unterprogramms ging auf Anhieb!!!
http://www.mikrocontroller.net/articles/FAQ#itoa.28.29_.28utoa.28.29.2C_ltoa.28.29.2C_ultoa.28.29.2C_ftoa.28.29_.29
Es verhlt sich genauso wie das bisher bekannte aus er Bibliothek. Der alte Fehler bleibt:
Wenn nach einer zweistelligen Zahl eine einstellige erscheinen soll, bleibt die zweite Ziffer auf dem LCD stehen und 
es ist eine scheinbar falsche Zahl zu lesen. Wenn man das LCD jedes Mal vor der ausgabe lschen wrde, wrde 
die Zahl richtig erscheinen.

Abhilfe:
In die Funktion ItoA mte noch eine Abfrage hinzu kommen, die fr einstellige Zahlen, also Zahlen kleiner 10, 
eine Null als Zeichen vorher ausgibt und erst dann wie bisher die ausgerechnete Ziffer anzeigt. 
Die einstellige Ziffer soll an die letzte Stelle kommen!

OK, aber es wird immer ein Leerzeichen davor geschrieben und zweistellige Zahlen sind dahinter dann lnger.
--->> keine falsche Darstellung mehr, aber nicht ganz was ich wollte.

*/


void ItoA( int z, char* Buffer )
{
  int i = 0;		//Laufvariable fr Buffer
  int j;
  char tmp;
  unsigned u;    // In u bearbeiten wir den Absolutbetrag von z.
 
    // ist die Zahl negativ?
    // gleich mal ein - hinterlassen und die Zahl positiv machen
    if( z < 0 ) {
      Buffer[0] = '-';
      Buffer++;
      // -INT_MIN ist idR. grer als INT_MAX und nicht mehr 
      // als int darstellbar! Man muss daher bei der Bildung 
      // des Absolutbetrages aufpassen.
      u = ( (unsigned)-(z+1) ) + 1; 
    }
    else { 
      u = (unsigned)z;
    }
	


/*	
	//Zustzliches Experiment:
	if ( u < 10 ) 
		{
		Buffer[0] = ' ';
		i++;		// <<--- das ist falsch! i um eins erhhen, da das erste Element bereits belegt ist.
		}
	//OK, aber es wird immer ein Leerzeichen davor geschrieben und zweistellige Zahlen sind dahinter dann lnger.
	//--->> keine falsche Darstellung mehr, aber nicht ganz was ich wollte.
*/	
	
/*

		//Zustzliches Experiment fr zweistellige Zahlen 0...99:
	if ( u < 10 ) 
		{
		Buffer[0] = ' ';	//Achtung! das stimmt fr negative Zahlen nicht mehr, oben bereits in Buffer[0] das Minus-Zeichen geschrieben wird.
	//	i++;		// <<--- das ist falsch!  i um eins erhhen, da das erste Element bereits belegt ist.
		Buffer++;	//richtig!
		}
	// OK, funktioniert!!! die Ausgabe ist rechtsbndig fr zweistellige Zahlen.
	
*/	
	

		//Zustzliches Experiment fr dreistellige Zahlen:
	if ( u < 100 ) 
		{
		Buffer[0] = ' ';	//Achtung! das stimmt fr negative Zahlen nicht mehr, oben bereits in Buffer[0] das Minus-Zeichen geschrieben wird.
		Buffer++; // weil man die erste Stelle beschrieben hat, eins weiter.
		//i = i + 1;	darf hier nicht stehen
		}
		
		
		if ( u < 10 ) 
		{
		Buffer[0] = ' ';	//wiederholtes  Beschrieben dieses Elementes. 
		Buffer[1] = ' ';	//Achtung! das stimmt fr negative Zahlen nicht mehr, oben bereits in Buffer[0] das Minus-Zeichen geschrieben wird.
		Buffer++;	// weil man die zweite Stelle beschrieben hat, noch eins weiter.
		i = i + 2;	//Laufindex korrigieren
		}
		//stimmt leider nicht! schreibt die Einerstellen rechtsbndig, aber lscht die Zehnerstellen nicht mehr.
		//stimmt jetzt doch!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Buffer[0] = ' '; hinzugefgt.
	
	
	
	
	
	
    // die einzelnen Stellen der Zahl berechnen
    do {
      Buffer[i++] = '0' + u % 10;
      u /= 10;
    } while( u > 0 );
 
    
	
	
	// den String in sich spiegeln
    for( j = 0; j < i / 2; ++j ) {
      tmp = Buffer[j];
      Buffer[j] = Buffer[i-j-1];
      Buffer[i-j-1] = tmp;
    }
    Buffer[i] = '\0';		//Ende-Zeichen anhngen
}



int main( void )
{
  uint i;
  char s[10];
  
  char t[10];	//Buffer fr die Testweisen Experimente

  TCCR0 = 1<<CS02;			//divide by 256
  TIMSK = 1<<TOIE0;			//enable timer interrupt

  
PORTB = 0b00010000;   // PortD , PD6 auf Pullup= ein schalten 

DDRB = 0x00;	//1 << DDB4;
PORTB = 1<< PB4;


/*
lcd_init();
_delay_ms( 10 );

lcd_string("Hello World!_itoa_rc5.c");
_delay_ms( 600);
lcd_setcursor( 0, 2 );		//Spalte 0, Zeile2


  sei();
*/  

  for(;;)				// main loop
	{
    cli();
	PORTB ^= (1 << PB0);    // LED toggeln PB0
		

/*	
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
*/
	i = 5;		//hier jeweils eine Zahl 0..65535 eingeben, die dann per ItoA in einen String gewandelt werden soll


    if( i )
		{
	  

		ItoA ( i , s );		//Verwendung des neuen Unterprogramms ging auf Anhieb!!!

      
		lcd_string( s );
	  
		lcd_data( ' ');
	  

		ItoA ( i , s );	//Verwendung des neuen Unterprogramms ging auf Anhieb!!!

		lcd_string( s );

	  
		//ab hier Tests mit dem Buffer:
		
		//lcd_setcursor( 12, 2 );		//Spalte 12, Zeile2, hinter die bisherige Ausgabe schreiben, erscheint dann an 9ter Stelle
		
		/*
		for( j = 0; j < i / 2; ++j ) {
		tmp = Buffer[j];
		Buffer[j] = Buffer[i-j-1];
		Buffer[i-j-1] = tmp;
		Buffer[i] = '\0';	
		*/
		
		t [0] = '2';	//Steht dann an neunter Stelle
		
		t [1] = '7';
		
		t [2] = ' ';
		
		t [3] = 'g';
		
		t [4] = '\0';		//Ende-Zeichen anhngen, mu immer !!! das darauf folgende Element sein!
	
		
		lcd_string( t );		//manipulierten t-Buffer-Inhalt ausgeben
		
		
		
		
//		if( ((i & 0x3F) | (~i >> 6 & 0x40)) == 54 )	// Picture-Taste bewirkt Lschung des LCDs.
			{
			lcd_clear();
			}
		
		//Ende ab hier Tests mit dem Buffer:		
		//lcd_setcursor( 0, 2 );		//Spalte 0, Zeile2
		
		}
	}	//Ende for (;;)
 }


/*
Was das ausgebende Unterprogramm aus den "LCD-Routines.c" macht:

// Schreibt einen String auf das LCD
 
void lcd_string( const char *data )
{
    while( *data != '\0' )
        lcd_data( *data++ );
}
*/


/*
Das Grundprinzip ist einfach:
Die Ermittlung der einzelnen Stellen erfolgt in der zentralen Schleife

    do {
      Buffer[i++] = '0' + u % 10;
      u /= 10;
    } while( u > 0 );

durch fortgesetzte Division durch 10 und Restbildung.

   8392

   8392 % 10           -> 2
   8392 / 10  -> 839

    839 % 10           -> 9
    839 / 10  -> 83

     83 % 10           -> 3
     83 / 10  -> 8

      8 % 10           -> 8
      8 / 10  -> 0


Nur leider erhlt man dadurch die einzelnen Ziffern der Zahl in umgekehrter Reihenfolge im String ('2' '9' '3' '8' anstelle von '8' '3' '9' '2'). Dies ist aber kein Problem, die nachfolgende Schleife

  for( j = 0; j < i / 2; ++j ) {
    tmp = Buffer[j];
    Buffer[j] = Buffer[i-j-1];
    Buffer[i-j-1] = tmp;
  }

spiegelt den String in sich, sodass danach der String eine korrekte Reprsentation der ursprnglichen Zahl darstellt. Der Funktionsteil vor der 'Zerlegeschleife' behandelt den Sonderfall da die Zahl negativ ist. Negative Zahlen werden behandelt indem im Endergebnis ein '-' vermerkt wird und danach die Zahl positiv gemacht wird.



*/
